<?php

/**
* Round Auto-End plugin.
* Ends the current round after a magically computed amount of time.
* Created by -nocturne=-
*
* Dependencies: none
*/

Aseco::registerEvent('onNewChallenge', 'set_timer');
Aseco::registerEvent('onBeginRound', 'start_timer');
Aseco::registerEvent('onMainLoop', 'check_timer');
Aseco::registerEvent('onEndRound', 'disable_timer');

global $IsInRounds, $round_timer, $round_time, $round_active, $rt_debug;

$rt_debug = false;

//Redundancy - Don't Touch
$IsInRounds = false;
$round_timer = 0;
$round_time = 0;
$round_active = false;

function set_timer($aseco) {
   global $IsInRounds, $round_timer, $round_active, $rt_debug;
   $round_active = false; //probably redundant, but oh well
   $IsInRounds = checkRounds($aseco);

   if (!$IsInRounds) {
      return;
   }

   $aseco->client->query('GetCurrentChallengeInfo');
   $result = $aseco->client->getResponse();
   $authortime = $result['AuthorTime'] / 1000;
   $round_timer = ($authortime * 1.10) + 5;
   $round_timer = round($round_timer);

   if ($rt_debug) {
      $aseco->console_text('[RoundTimer] Author Time: ' . $authortime . '  Round Time:' . $round_timer);
   }
}

function start_timer($aseco) {
   global $IsInRounds, $round_time, $round_timer, $round_active;

   if ($IsInRounds) {
      $round_time = $round_timer + time();
      $round_active = true;

      if ($rt_debug) {
         $aseco->console_text('[RoundTimer] Round Started!');
      }
   }
}

function check_timer($aseco) {
   global $IsInRounds, $round_active, $round_time, $round_timer;

   if ($IsInRounds && $round_active && time() > $round_time) {
      $aseco->client->query('ForceEndRound');
      $round_active = false;
      $aseco->client->query('ChatSendServerMessage', '$fff$iRound automatically ended!');
      $aseco->console_text('[RoundTimer] Round automatically ended after ' . $round_timer . 'secs...');
   }
}

function disable_timer($aseco) {
   global $IsInRounds, $round_active, $rt_debug;

   if ($IsInRounds && $round_active) {
      $round_active = false;

      if ($debug) {
         $aseco->console_text('[RoundTimer] End of round...');
      }
   }
}

function checkRounds($aseco) {
   global $rt_debug, $round_timer;

   if ($aseco->server->gameinfo->mode == 0) {
      if ($rt_debug) {
         $aseco->console_text('[RoundTimer] In Rounds...');
      }
      return true;
   } else {
      if ($round_timer) {
         unset($round_timer);
      }

      if ($rt_debug) {
         $aseco->console_text('[RoundTimer] Not in rounds... Should not do anything.');
      }
      return false;
   }
}
?>